# frozen_string_literal: true

module PlanetExpress
  class DiscountBudget
    attr_reader :budget, :available_budget

    def initialize(budget:)
      @budget = budget
      @available_budget = budget
    end

    def register_applied_discount(discount_amount)
      possible_discount = maximum_possible_discount(discount_amount)
      @available_budget = available_budget - possible_discount
      possible_discount
    end

    def maximum_possible_discount(discount_amount)
      [available_budget, discount_amount].min
    end

    def remaining_budget?
      !available_budget.zero?
    end
  end
end
