# frozen_string_literal: true

module PlanetExpress
  class DiscountBudgetForMonthRepository
    DEFAULT_BUDGET = 1000
    attr_reader :data

    def initialize(data: {})
      @data = Hash.new do |hash, key|
        hash[key] = DiscountBudget.new(budget: DEFAULT_BUDGET)
      end.merge(data)
    end

    def for_month(date)
      data[start_of_month(date)]
    end

    private

    def start_of_month(date)
      Date.new(date.year, date.month, 1)
    end
  end
end
