# frozen_string_literal: true

module PlanetExpress
  class Repository
    include Enumerable

    attr_reader :data

    def initialize(data:)
      @data = data
    end

    def all
      data
    end

    def each(&block)
      data.each(&block)
    end

    def add(item)
      data.push(item)
    end

    def remove(item)
      data.delete(item)
    end

    def where(attribute_matchers = {})
      all.select do |entry|
        attribute_matchers.map do |attribute, value|
          entry.public_send(attribute.to_sym) == value
        end.all?
      end
    end
  end
end
