# frozen_string_literal: true

module PlanetExpress
  ShippingOption = Struct.new(:provider, :package_size, :price_in_cents) do
    def s_shipment?
      package_size == 'S'
    end

    def l_shipment?
      package_size == 'L'
    end

    def lp_provider?
      provider == 'LP'
    end

    def inspect
      "ShippingOption [proivder=#{provider} package_size=#{package_size} price_in_cents=#{price_in_cents}]"
    end
  end
end
